<template>
<div class="modal inmodal" id="pan_modal">
    <div class="modal-dialog modal-lg">
        <div class="modal-content animated fadeIn">
            <div class="ibox-title">
                <h5>PAN Form</h5>
            </div>
            <!-- /.ibox-title -->

            <div class="ibox-content" v-bind:class="{ 'sk-loading': modal.pause_save }">
                <div class="sk-spinner sk-spinner-wave">
                    <div class="sk-rect1"></div>
                    <div class="sk-rect2"></div>
                    <div class="sk-rect3"></div>
                    <div class="sk-rect4"></div>
                    <div class="sk-rect5"></div>
                </div>

                <div class="row">
                    <div class="col-sm-12 col-md-4 col-lg-4"
                            v-bind:class="{ 'has-error': modal.errors.nature  }"
                    >
                        <div class="form-group" id="error_name">
                            <label for="name">Nature : </label>
                            <select class="form-control"
                                    v-model="modal.data.nature" 
                            > 
                                <option value="">PLEASE CHOOSE</option>
                                <option value="TRAINEE">TRAINEE</option>
                                <option value="REGULAR">REGULAR</option>
                                <option value="PROBATIONARY">PROBATIONARY</option>
                                <option value="CONTRACTUAL">CONTRACTUAL</option>
                                <option value="PROMOTION">PROMOTION</option>
                                <option value="TRANSFER">TRANSFER</option>
                                <option value="RECLASSIFICATION">RECLASSIFICATION</option>
                                <option value="SALARY">SALARY</option>
                                <option value="SEPARATION">SEPARATION</option>
                                <option value="OTHERS">OTHERS</option>
                            </select>

                            <div v-if="modal.errors.nature">
                                <span class="help-block" v-for="error in modal.errors.nature" :key="error.id">
                                * {{ error }}
                                </span>
                            </div>
                        </div>
                    </div>

                    <div class="col-sm-12 col-md-4 col-lg-4"
                            v-bind:class="{ 'has-error': modal.errors.department  }"
                    >
                        <div class="form-group" id="error_name">
                            <label for="name">Department : </label>
                            <select class="form-control"
                                    v-model="modal.data.department" 
                            > 
                                <option value="">PLEASE CHOOSE</option>
                                <option value="CONSTRUCTION">CONSTRUCTION</option>
                                <option value="EXECUTIVE">EXECUTIVE</option>
                                <option value="ACCOUNTING">ACCOUNTING</option>
                            </select>

                            <div v-if="modal.errors.department">
                                <span class="help-block" v-for="error in modal.errors.department" :key="error.id">
                                * {{ error }}
                                </span>
                            </div>
                        </div>
                    </div>

                    <div class="col-sm-12 col-md-4 col-lg-4"
                            v-bind:class="{ 'has-error': modal.errors.superior  }"
                    >
                        <div class="form-group" id="error_name">
                            <label for="name">Superior : </label>
                            <select class="form-control"
                                    v-model="modal.data.superior" 
                            >   
                                <option value="">Select one...</option>
                                <option  v-for="employee in employees" :key  ="employee.id"
                                        :value="employee.id"
                                >{{ employee.full_name }}</option>
                            </select>

                            <div v-if="modal.errors.superior">
                                <span class="help-block" v-for="error in modal.errors.superior" :key="error.id">
                                * {{ error }}
                                </span>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- ./row -->

                <div class="row">
                    <div class="col-sm-12 col-md-4 col-lg-4"
                            v-bind:class="{ 'has-error': modal.errors.effectivity  }"
                    >
                        <div class="form-group" id="error_name">
                            <label for="name">Effectivity Date : </label>
                            <input type="date" class="form-control"  v-model="modal.data.effectivity">

                            <div v-if="modal.errors.effectivity">
                                <span class="help-block" v-for="error in modal.errors.effectivity" :key="error.id">
                                * {{ error }}
                                </span>
                            </div>
                        </div>
                    </div>

                    <div class="col-sm-12 col-md-4 col-lg-4"
                            v-bind:class="{ 'has-error': modal.errors.pay_class  }"
                    >
                        <div class="form-group" id="error_name">
                            <label for="name">Pay Class : </label>
                            <select class="form-control"
                                    v-model="modal.data.pay_class"
                            >   
                                <option value="">PLEASE CHOOSE</option>
                                <option value="MONTHLY">MONTHLY</option>
                                <option value="DAILY">DAILY</option>
                            </select>

                            <div v-if="modal.errors.pay_class">
                                <span class="help-block" v-for="error in modal.errors.pay_class" :key="error.id">
                                * {{ error }}
                                </span>
                            </div>
                        </div>
                    </div>

                    <div class="col-sm-12 col-md-4 col-lg-4"
                            v-bind:class="{ 'has-error': modal.errors.pay_13th  }"
                    >
                        <div class="form-group" id="error_name">
                            <label for="name">13th MONTH : </label>
                            <input type="number" min="0" class="form-control"  v-model="modal.data.pay_13th">

                            <div v-if="modal.errors.pay_13th">
                                <span class="help-block" v-for="error in modal.errors.pay_13th" :key="error.id">
                                * {{ error }}
                                </span>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- ./row -->

                <div class="row">
                    <div class="col-sm-12 col-md-12 col-lg-12"
                            v-bind:class="{ 'has-error': modal.errors.job_title  }"
                    >
                        <div class="form-group" id="error_name">
                            <label for="name">Job Title : </label>
                            <input class="form-control"  v-model="modal.data.job_title">

                            <div v-if="modal.errors.job_title">
                                <span class="help-block" v-for="error in modal.errors.job_title" :key="error.id">
                                * {{ error }}
                                </span>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- ./row -->

                <div class="row">
                    <div class="col-sm-12 col-md-12 col-lg-12"
                            v-bind:class="{ 'has-error': modal.errors.remarks  }"
                    >
                        <div class="form-group" id="error_name">
                            <label for="name">Remarks : </label>
                            <textarea class="form-control"  v-model="modal.data.remarks">
                            </textarea>

                            <div v-if="modal.errors.remarks">
                                <span class="help-block" v-for="error in modal.errors.remarks" :key="error.id">
                                * {{ error }}
                                </span>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- ./row -->

                <hr>

                <!-- Salary -->
                <div class="row">
                    <div class="col-sm-12 col-md-6 col-lg-6 b-r">
                        <h3 class="m-t-none m-b"><i>Allowance</i></h3>
                        <div class="form-horizontal">
                            <div class="form-group" v-bind:class="{ 'has-error': modal.errors.rice_allow  }">
                                <label class="col-lg-4 control-label">Rice :</label>
                                <div class="col-lg-8">
                                    <input type="number" min="0" class="form-control" v-model.number="modal.data.rice_allow">

                                    <div v-if="modal.errors.rice_allow">
                                        <span class="help-block m-b-none" v-for="error in modal.errors.rice_allow" :key="error.id">
                                        * {{ error }}
                                        </span>
                                    </div>
                                </div>
                            </div>

                            <div class="form-group" v-bind:class="{ 'has-error': modal.errors.laundry_allow  }">
                                <label class="col-lg-4 control-label">Laundry :</label>
                                <div class="col-lg-8">
                                    <input type="number" min="0" class="form-control" v-model.number="modal.data.laundry_allow">

                                    <div v-if="modal.errors.laundry_allow">
                                        <span class="help-block m-b-none" v-for="error in modal.errors.laundry_allow" :key="error.id">
                                        * {{ error }}
                                        </span>
                                    </div>
                                </div>
                            </div>

                            <div class="form-group" v-bind:class="{ 'has-error': modal.errors.clothing_allow  }">
                                <label class="col-lg-4 control-label">Clothing :</label>
                                <div class="col-lg-8">
                                    <input type="number" min="0" class="form-control" v-model.number="modal.data.clothing_allow">

                                    <div v-if="modal.errors.clothing_allow">
                                        <span class="help-block m-b-none" v-for="error in modal.errors.clothing_allow" :key="error.id">
                                        * {{ error }}
                                        </span>
                                    </div>
                                </div>
                            </div>

                            <div class="form-group" v-bind:class="{ 'has-error': modal.errors.medical_allow  }">
                                <label class="col-lg-4 control-label">Medical :</label>
                                <div class="col-lg-8">
                                    <input type="number" min="0" class="form-control" v-model.number="modal.data.medical_allow">

                                    <div v-if="modal.errors.medical_allow">
                                        <span class="help-block m-b-none" v-for="error in modal.errors.medical_allow" :key="error.id">
                                        * {{ error }}
                                        </span>
                                    </div>
                                </div>
                            </div>

                            <div class="form-group" v-bind:class="{ 'has-error': modal.errors.ob_allow  }">
                                <label class="col-lg-4 control-label">OB :</label>
                                <div class="col-lg-8">
                                    <input type="number" min="0" class="form-control" v-model.number="modal.data.ob_allow">

                                    <div v-if="modal.errors.ob_allow">
                                        <span class="help-block m-b-none" v-for="error in modal.errors.ob_allow" :key="error.id">
                                        * {{ error }}
                                        </span>
                                    </div>
                                </div>
                            </div>
                            
                            <div class="form-group" v-bind:class="{ 'has-error': modal.errors.ecola  }">
                                <label class="col-lg-4 control-label">Ecola. :</label>
                                <div class="col-lg-8">
                                    <input type="number" min="0" class="form-control" v-model.number="modal.data.ecola">

                                    <div v-if="modal.errors.ecola">
                                        <span class="help-block m-b-none" v-for="error in modal.errors.ecola" :key="error.id">
                                        * {{ error }}
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="col-sm-12 col-md-6 col-lg-6">
                        <h3 class="m-t-none m-b">&nbsp;</h3>

                        <div class="form-horizontal">
                            <div class="form-group" v-bind:class="{ 'has-error': modal.errors.basic_salary  }">
                                <label class="col-lg-4 control-label">Basic Salary :</label>
                                <div class="col-lg-8">
                                    <input type="number" min="0" class="form-control" v-model.number="modal.data.basic_salary">

                                    <div v-if="modal.errors.basic_salary">
                                        <span class="help-block m-b-none" v-for="error in modal.errors.basic_salary" :key="error.id">
                                        * {{ error }}
                                        </span>
                                    </div>
                                </div>
                            </div>

                            <div class="form-group" v-bind:class="{ 'has-error': modal.errors.other_allow  }">
                                <label class="col-lg-4 control-label">Other Allow. :</label>
                                <div class="col-lg-8">
                                    <input type="number" min="0" class="form-control" v-model.number="modal.data.other_allow">

                                    <div v-if="modal.errors.other_allow">
                                        <span class="help-block m-b-none" v-for="error in modal.errors.other_allow" :key="error.id">
                                        * {{ error }}
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <hr>

                        <!-- Total -->

                        <div class="form-horizontal">
                            <div class="row">
                                <label class="col-lg-8 text-right">BASIC PAY :</label>
                                <div class="col-lg-4">
                                    <span class="pull-right">{{ modal.data.basic_salary | formatNumber}}</span>
                                </div>
                            </div>

                            <div class="row">
                                <label class="col-lg-8 text-right">TOTAL ALLOWANCES  :</label>
                                <div class="col-lg-4">
                                    <span class="pull-left">+</span>
                                    <span class="pull-right">{{  total_allowance | formatNumber}}</span>
                                </div>
                            </div>
                            <hr>
                            <div class="row">
                                <label class="col-lg-8 text-right">TOTAL SALARY :</label>
                                <div class="col-lg-4">
                                    <span class="pull-right">{{  total_salary | formatNumber}}</span>
                                </div>
                            </div>
                            <div class="row">
                                <label class="col-lg-8 text-right">OTHER ALLOWANCES  :</label>
                                <div class="col-lg-4">
                                    <span class="pull-left">+</span>
                                    <span class="pull-right">{{ modal.data.other_allow | formatNumber}}</span>
                                </div>
                            </div>
                            <hr>
                            <div class="row">
                                <label class="col-lg-8 text-right">TOTAL INCOME :</label>
                                <div class="col-lg-4">
                                    <span class="pull-left">P</span>
                                    <span class="pull-right">{{  total_income | formatNumber}}</span>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- ./Salary -->
            </div>
            <!-- /.ibox-content -->
            <div class="ibox-footer">
              <div class="pull-right">
                <button type="button" class="btn btn-white btn-sm " data-dismiss="modal">
                  Close
                </button>

                <button @click="save()" 
                        :disable="modal.pause_save" 
                        class="btn btn-flat btn-primary btn-sm"> 
                  Save
                </button>
              </div>
              <div>&nbsp;<br>&nbsp;</div>
            </div>
            <!-- /.ibox-footer -->
        </div>
        <!-- /.modal-content animated flipInY -->
    </div>
    <!-- /.modal-dialog -->
</div>
<!-- /.modal inmodal -->

</template>

<style scoped>
hr { 
    margin-top: 5px;
    margin-bottom: 5px;
}

input[type='number']{
    text-align: right;
}
</style>

<script>
export default {
    props: [
        'modal'
    ],
    data () {
        return {
            employees: {}
        }
    },
    computed: {
        total_allowance: function () {
            let total_allowance = 0
            total_allowance += this.modal.data.rice_allow
            total_allowance += this.modal.data.laundry_allow
            total_allowance += this.modal.data.clothing_allow
            total_allowance += this.modal.data.medical_allow
            total_allowance += this.modal.data.ob_allow
            total_allowance += this.modal.data.ecola
            return total_allowance
        },
        total_salary: function () {
            let total_salary = 0
            total_salary += this.modal.data.basic_salary
            total_salary += window.parseFloat(this.total_allowance)
            return total_salary
        },
        total_income: function () {
            let total_allowance = 0
            
            total_allowance += this.modal.data.other_allow
            total_allowance +=  window.parseFloat(this.total_salary)

            return total_allowance
        }
    },
    methods: {
        save() {
            this.$emit('save', this.modal.data)
        },
        get_employee_list() {
            axios.get('employee?for_list=true').then(response => {
                this.employees = response.data.employees
            })
        }
    },
    created() {
        this.get_employee_list()
    }
}
</script>
